require 'middleclass'

BgBox = class('BgBox')

function BgBox:initialize(x,y,w,h)
	self.x = x
	self.y = y
	self.w = w
	self.h = h
	self.points = {}
end

function BgBox:addPoint(time,r,g,b)
	table.insert(self.points, {time,r,g,b})
end

function BgBox:draw(time)
	firstpoint = {}
	lastpoint = {}
	if time < self.points[1][1] then
		love.graphics.setColor(self.points[1][2],self.points[1][3],self.points[1][4],255)
		love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
		love.graphics.setColor(255,255,255,255)
	return
	end
	if time > self.points[#self.points][1] then
		love.graphics.setColor(self.points[#self.points][2],self.points[#self.points][3],self.points[#self.points][4],255)
		love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
		love.graphics.setColor(255,255,255,255)
	return
	end

	for b=1,#(self.points) do
		if self.points[b][1] < time then 
			firstpoint = self.points[b] 
		end
	end
	for b=#(self.points),1,-1 do
		if self.points[b][1] > time then 
			lastpoint = self.points[b] 
		end
	end

	if #firstpoint == 0 or #lastpoint == 0 then
		firstpoint = self.points[1]
		lastpoint = self.points[#self.points]
	end

	love.graphics.setColor(firstpoint[2],firstpoint[3],firstpoint[4],255)
	love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
	local fadealpha = 255*((time-firstpoint[1])/(lastpoint[1]-firstpoint[1]))
	love.graphics.setColor(lastpoint[2],lastpoint[3],lastpoint[4],fadealpha)
	love.graphics.rectangle("fill",self.x,self.y,self.w,self.h)
	love.graphics.setColor(255,255,255,255)
end

Background = class('Background')

function Background:initialize()
	sky = BgBox:new(0,0,1024,280)
	sky:addPoint(0,230,230,230)
	sky:addPoint(200,230,230,230)
	sky:addPoint(15000,0,230,230)
	sky:addPoint(25000,128,230,230)
	sky:addPoint(50000,128,230,230)
	sky:addPoint(85000,46,230,230)

	floor = BgBox:new(0,768-554,1024,554)
	floor:addPoint(0,179,179,179)
	floor:addPoint(75000,179,179,179)
	floor:addPoint(75500,83,159,83)

	box1 = BgBox:new(  3,768-487-195,110,195)
	box2 = BgBox:new(117,768-487-132,103,132)
	box3 = BgBox:new(227,768-487-162,103,162)
	box4 = BgBox:new(337,768-487-190,220,190)
	box5 = BgBox:new(568,768-487-161,77,161)
	box6 = BgBox:new(659,768-487-106,280,106)
	box7 = BgBox:new(948,768-487-220,83,220)

	box1:addPoint(100,102,102,102)
	box2:addPoint(100,128,128,128)
	box3:addPoint(100,102,102,102)
	box4:addPoint(100,128,129,128)
	box5:addPoint(100,102,102,102)
	box6:addPoint(100,128,128,128)
	box7:addPoint(100,153,153,153)

	box1:addPoint(2000,102,102,102)
	box1:addPoint(4500,145,111,111)

	box2:addPoint(4500,128,128,128)
	box2:addPoint(10500,128,128,128)

	box4:addPoint(8100,93,93,128)

	box7:addPoint(8100,43,43,128)
	box7:addPoint(17500,212,170,0)

	box6:addPoint(16500,108,83,83)
	box6:addPoint(45000,145,111,111)
	
	box1:addPoint(75000,200,55,55)
	box2:addPoint(75000,233,158,107)
	box3:addPoint(75000,200,55,55)
	box4:addPoint(75000,172,147,147)
	box5:addPoint(75000,222,135,135)
	box6:addPoint(75000,128,128,128)
	box7:addPoint(75000,233,158,107)

	box1:addPoint(90000,0,155,157)
	box2:addPoint(90000,0,190,193)
	box3:addPoint(90000,0,155,157)
	box4:addPoint(90000,0,126,128)
	box5:addPoint(90000,0,155,157)
	box6:addPoint(90000,0,190,193)
	box7:addPoint(90000,0,155,157)

end


function Background:draw(utopia)
	sky:draw(utopia)
	floor:draw(utopia)

	box1:draw(utopia)
	box2:draw(utopia)
	box3:draw(utopia)
	box4:draw(utopia)
	box5:draw(utopia)
	box6:draw(utopia)
	box7:draw(utopia)
end
