require 'middleclass'

BasicWalker = class('BasicWalker')

function BasicWalker:initialize(startpoint,endpoint)
	self.art = art
	self.startpoint = startpoint
	self.endpoint = endpoint
	self.position = {0,0}
	self.position[1] = self.startpoint[1]
	self.position[2] = self.startpoint[2]
	self.flip = math.random() > 0.5
	self.timesince = 0

	self.v = {0,0}
	self.v[1] = (self.endpoint[1] - self.startpoint[1])
	self.v[2] = (self.endpoint[2] - self.startpoint[2])
	self.timeend = math.sqrt( self.v[1]*self.v[1] + self.v[2]*self.v[2] ) / 100
end

function BasicWalker:update(dt)
	self.timesince = self.timesince + dt
	self.position[1] = self.startpoint[1] + self.v[1]*(self.timesince/self.timeend)
	self.position[2] = self.startpoint[2] + self.v[2]*(self.timesince/self.timeend)
end

function BasicWalker:draw()
	if math.floor(self.timesince*5) % 2 == 1 then
		love.graphics.draw(art["standing1"], self.position[1], self.position[2])
	else
		love.graphics.draw(art["thinstanding1"], self.position[1], self.position[2])
	end
end

function BasicWalker:stillWalking()
	return (self.timesince < self.timeend)
end

function BasicWalker:angry() return false end
