require 'middleclass'
require 'basicwalker'
require 'parameter'
require 'background'
require 'protestor'
require 'protest'

Game = class('Game')

function Game:load()
	love.graphics.setFont(love.graphics.newFont(18))

	bg = Background:new()

	art = {}
	art["protest1"] = love.graphics.newImage("stickmen/protest1.png")
	art["protest2"] = love.graphics.newImage("stickmen/protest2.png")
	art["protestsign1"] = love.graphics.newImage("stickmen/protestsign1.png")
	art["protestsign2"] = love.graphics.newImage("stickmen/protestsign2.png")
	art["standing1"] = love.graphics.newImage("stickmen/standing1.png")
	art["thinstanding1"] = love.graphics.newImage("stickmen/thinstanding1.png")
	art["star"] = love.graphics.newImage("star.png")
	art["revo"] = love.graphics.newImage("revo.png")

	love.graphics.setBackgroundColor(204,204,204,255)

	p1 = Parameter:new("Liberty",{1,0,0})
	p2 = Parameter:new("Equality",{1,1,0})
	p3 = Parameter:new("Fraternity",{0,1,0})
	p4 = Parameter:new("Justice",{0,1,1})
	p5 = Parameter:new("Cake",{0,0,1})
	p6 = Parameter:new("Tradition",{1,0,1})

	totaltime = 0
	timeOfRevolutionCheck = 15
	timeOfStarCheck = 0
	timeOfRevo = -9999

	ps = {p1,p2,p3,p4,p5,p6}
	ps[math.random(6)]:showStar(true)

	utopia = 100
	largestutopia = 100

	wanderers = {}

	protests = {}

	self.changeto = ""
end

function Game:update(dt)

	if (largestutopia < 2500) then
		difficulty_shiftmagnitude = 5 
		difficulty_shiftduration = 10
		difficulty_totalparam = 350
		difficulty_easilyannoyed = 1
		difficulty_easilyangry = 3
	elseif (largestutopia < 5000) then
		difficulty_shiftmagnitude = 10
		difficulty_shiftduration = 10
		difficulty_totalparam = 350
		difficulty_easilyannoyed = 1.2
		difficulty_easilyangry = 5
	elseif (largestutopia < 10000) then
		difficulty_shiftmagnitude = 20
		difficulty_shiftduration = 5
		difficulty_totalparam = 300
		difficulty_easilyannoyed = 1.2
		difficulty_easilyangry = 6
	elseif (largestutopia < 20000) then
		difficulty_shiftmagnitude = 30
		difficulty_shiftduration = 3
		difficulty_totalparam = 300
		difficulty_easilyannoyed = 1.5
		difficulty_easilyangry = 8
	elseif (largestutopia < 50000) then
		difficulty_shiftmagnitude = 30
		difficulty_shiftduration = 1
		difficulty_totalparam = 250
		difficulty_easilyannoyed = 2.5
		difficulty_easilyangry = 8
	elseif (largestutopia < 75000) then
		difficulty_shiftmagnitude = 40
		difficulty_shiftduration = 1
		difficulty_totalparam = 250
		difficulty_easilyannoyed = 2.5
		difficulty_easilyangry = 1
	elseif (largestutopia < 100000) then
		print("you win!")
	end

	local ps = {p1,p2,p3,p4,p5,p6}

	for i=1,#protests do
		protests[i]:update(dt)
	end

	totaltime = totaltime + dt
	p1:update(dt)
	p2:update(dt)
	p3:update(dt)
	p4:update(dt)
	p5:update(dt)
	p6:update(dt)

   	if love.mouse.isDown("l") then
		for i=1,#ps do
			ps[i]:checkClick(love.mouse.getPosition())
		end
	end

	local totalParam = p1.param+p2.param+p3.param+p4.param+p5.param+p6.param
	while totalParam > difficulty_totalparam do
		for i=1,#ps do
			ps[i].param = ps[i].param - ps[i].param*0.01
		end
		totalParam = p1.param+p2.param+p3.param+p4.param+p5.param+p6.param
	end
	--[[
   	if love.mouse.isDown("l") then
		for i=1,#ps do
			if ps[i]:checkClick(love.mouse.getPosition()) then
				local totalParam = p1.param+p2.param+p3.param+p4.param+p5.param+p6.param
				print(totalParam)
				if totalParam > 250 then
					for j=1,#ps do
						if i ~= j then
							ps[j].param = ps[j].param - 5*(totalParam-250)
						end
					end
				end
			end
		end
	end
	]]--

   	if love.mouse.isDown("l") then
		p1:checkClick(love.mouse.getPosition())
		p2:checkClick(love.mouse.getPosition())
		p3:checkClick(love.mouse.getPosition())
		p4:checkClick(love.mouse.getPosition())
		p5:checkClick(love.mouse.getPosition())
		p6:checkClick(love.mouse.getPosition())
	end

	if math.floor(totaltime) > timeOfRevolutionCheck then
		for i=1,#ps do
			if     ps[i]:riskOfRebellion(1)  > math.random() * (5/difficulty_easilyannoyed) then
			table.insert(protests,Protest:new(ps[i],true))
			elseif ps[i]:riskOfRebellion(-1) > math.random() * (5/difficulty_easilyannoyed) then
			table.insert(protests,Protest:new(ps[i],false))
			end
		end
		timeOfRevolutionCheck = math.floor(totaltime) + 3
	end

	for i=1,#protests do
		if protests[i]:isRevolution() then
			p1:revolution()
			p2:revolution()
			p3:revolution()
			p4:revolution()
			p5:revolution()
			p6:revolution()
			utopia = utopia - 6000
			timeOfRevo = totaltime
		end

	end
--[[
	for i=1,#protests do
		if protests[i].forgotten then
			table.remove(protests,i)
		end
	end
	]]--

	for i=1,#ps do
		if ps[i].starred then
			utopia = utopia + ps[i].have*dt*2
		end
	end

	if utopia > largestutopia then largestutopia = utopia end

	if totaltime > timeOfStarCheck then
		for i=1,#ps do
			if ps[i].starred then
				ps[i]:showStar(false)
			end
		end
		ps[math.random(6)]:showStar(true)
		timeOfStarCheck = totaltime + math.random()*20
	end

	r = math.random()
	if r < 0.25*dt then
		wanderers[#wanderers+1] = BasicWalker:new( {0,246+math.random(554)},{1024,246+math.random(554)} )
	end
	if r < 0.25*dt then
		wanderers[#wanderers+1] = BasicWalker:new( {1024,246+math.random(554)},{0,246+math.random(554)} )
	end

	for w=1,#wanderers do
		wanderers[w]:update(dt)
	end

	if utopia < 0 then
		self.changeto = "gameover"
	elseif utopia > 100000 then
		self.changeto = "winner"
	end
end

function Game:draw()

	bg:draw(utopia)

	for w=1,#wanderers do
		wanderers[w]:draw()
	end   

	for p=1,#protests do
		protests[p]:draw()
	end

	love.graphics.setColor(100,100,100,255)
	love.graphics.rectangle("fill",635,445,1024-635,768-445)
	love.graphics.setColor(255,255,255,255)

	p1:draw(650,460+50*0)
	p2:draw(650,460+50*1)
	p3:draw(650,460+50*2)
	p4:draw(650,460+50*3)
	p5:draw(650,460+50*4)
	p6:draw(650,460+50*5)

	love.graphics.setColor(0,0,0,255)
	love.graphics.rectangle("fill",10,10,100000/100,10)
	love.graphics.setColor(255,255,255,255)
	love.graphics.rectangle("fill",10,10,utopia/100,10)

	if (totaltime - timeOfRevo < 2) then
		love.graphics.setColor(255,255,255,(255/2)*(2-(totaltime-timeOfRevo)))
		love.graphics.draw(art["revo"],200,200)
		love.graphics.setColor(255,255,255,255)
	end

end

function Game:changeTo()
	return self.changeto,largestutopia
end
