require 'middleclass'
require 'basicwalker'
require 'parameter'
require 'background'
require 'protestor'
require 'protest'
require 'game'
require 'mainmenu'
require 'gameover'
require 'help'

function love.load()
	love.graphics.setFont(love.graphics.newFont(18))
	running = MainMenu:new()
	running:load()
end

function love.update(dt)
	running:update(dt)

	changeto,changeval = running:changeTo()
	if changeto == "mainmenu" then
		running = MainMenu:new()
		running:load()
	elseif changeto == "newgame" then
		running = Game:new()
		running:load()
	elseif changeto == "winner" then
		running = Winner:new(changeval)
		running:load()
	elseif changeto == "gameover" then
		running = GameOver:new(changeval)
		running:load()
	elseif changeto == "help" then
		running = Help:new()
		running:load()
	elseif changeto == "quit" then
		love.event.quit()
	end
end

function love.draw()
	running:draw()
end

function love.keypressed(k)
	if k == 'escape' then
		running = MainMenu:new()
		running:load()
	end
end
