require 'middleclass'
require 'basicwalker'
require 'parameter'
require 'background'
require 'protestor'
require 'protest'
require 'help'

MainMenu = class('MainMenu')

function MainMenu:load()
	love.graphics.setFont(love.graphics.newFont(36))

	bg = Background:new()

	art = {}
	art["protest1"] = love.graphics.newImage("stickmen/protest1.png")
	art["protest2"] = love.graphics.newImage("stickmen/protest2.png")
	art["protestsign1"] = love.graphics.newImage("stickmen/protestsign1.png")
	art["protestsign2"] = love.graphics.newImage("stickmen/protestsign2.png")
	art["standing1"] = love.graphics.newImage("stickmen/standing1.png")
	art["thinstanding1"] = love.graphics.newImage("stickmen/thinstanding1.png")
	art["star"] = love.graphics.newImage("star.png")
	art["logo"] = love.graphics.newImage("logo.png")

	love.graphics.setBackgroundColor(204,204,204,255)

	p1 = Parameter:new("Liberty",{1,0,0})
	p2 = Parameter:new("Equality",{1,1,0})
	p3 = Parameter:new("Fraternity",{0,1,0})
	p4 = Parameter:new("Justice",{0,1,1})
	p5 = Parameter:new("Cake",{0,0,1})
	p6 = Parameter:new("Tradition",{1,0,1})

	totaltime = 0
	timeOfRevolutionCheck = 15
	timeOfStarCheck = 0

	ps = {p1,p2,p3,p4,p5,p6}
	ps[math.random(6)]:showStar(true)

	utopia = 5000
	largestutopia = 5000

	wanderers = {}

	protests = {}

	self.changeto = ""
end

function MainMenu:update(dt)
	if love.mouse.isDown("l") then
		local x,y = love.mouse.getPosition()
		if x > 600 and y >450 and y<500 then
			self.changeto = "newgame"
		elseif x > 600 and y >500 and y<550 then
			self.changeto = "help"
		elseif x > 600 and y >550 and y<600 then
			self.changeto = "quit"
		end
	end 

end

function MainMenu:draw()

	bg:draw(utopia)

	for w=1,#wanderers do
		wanderers[w]:draw()
	end   

	for p=1,#protests do
		protests[p]:draw()
	end

	love.graphics.draw(art["logo"],100,300)

	love.graphics.print("New Game",600,450)
	love.graphics.print("Controls",600,500)
	love.graphics.print("Quit",600,550)

end

function MainMenu:changeTo()
	return self.changeto,0
end
