require 'middleclass'

difficulty_shiftmagnitude = 4
difficulty_shiftduration = 15

Parameter = class('Parameter')

function Parameter:initialize(name,colour)
	self.name = name
	self.have = math.random()*100
	self.want = math.random()*100
	self.param = 250/6
	self.colour = colour --{1,0,0}

	self.Shift_TotalDuration = math.random()*2
	self.Shift_DurationSoFar = 0
	self.Shift_Magnitude = (math.random()-0.5)*3

	self.starred = false
end

function Parameter:update(dt)
	self.have = self.have + (self.param-self.have)*0.2*dt
	
	if (self.want > 95) then
		self.Shift_TotalDuration = math.random()*10
		self.Shift_DurationSoFar = 0
		self.Shift_Magnitude = (-1 * math.random())*10
	elseif (self.want < 2) then
		self.Shift_TotalDuration = math.random()*10
		self.Shift_DurationSoFar = 0
		self.Shift_Magnitude = math.random()*10
	end
	
	if (self.Shift_DurationSoFar > self.Shift_TotalDuration) then -- new shift!
		self.Shift_TotalDuration = math.random()*difficulty_shiftmagnitude
		self.Shift_DurationSoFar = 0
		self.Shift_Magnitude = (math.random()-0.5)*difficulty_shiftmagnitude
	else -- process current shift
		self.Shift_DurationSoFar = self.Shift_DurationSoFar + dt
		self.want = self.want + self.Shift_Magnitude*dt
	end

end

function Parameter:draw(x,y)
	self.x = x
	self.y = y
	love.graphics.setColor(0,0,0,255)

	love.graphics.print(self.name,x,y+4)

	love.graphics.rectangle("fill",x+100,y   ,256,12)
	love.graphics.rectangle("fill",x+100,y+14,256,12)
	love.graphics.rectangle("fill",x+100,y+28,256,12)

	love.graphics.setColor( 255*self.colour[1] , 255*self.colour[2] , 255*self.colour[3] ,255)
	love.graphics.rectangle("fill",x+100,y,self.param*(255/100),12)
	love.graphics.setColor( 127+127*self.colour[1] , 127+127*self.colour[2] , 127+127*self.colour[3] ,255)
	love.graphics.rectangle("fill",x+100,y+14,self.have*(255/100),12)
	love.graphics.setColor( 127*self.colour[1] , 127*self.colour[2] , 127*self.colour[3] ,255)
	love.graphics.rectangle("fill",x+100,y+28,self.want*(255/100),12)
	love.graphics.setColor(255,255,255,255)

	if (self.starred) then love.graphics.draw(art["star"],x+80,y) end
end

function Parameter:setParam(value)
	self.param = value
end

function Parameter:checkClick(x,y)
	if  x > self.x+100 and x < self.x+100+255 
	and y > self.y     and y < self.y+40
	then
		local clickParam = x - (self.x+100)
		self.param = clickParam * (100/255)
		return true
	end
	return false
end

function Parameter:riskOfRebellion(toohigh)
	if (toohigh == 1) then
		if self.want >= self.param then return 0 end
		return (self.param - self.want) / 100
	else -- toolow
		if self.want <= self.param then return 0 end
		return (self.want - self.param) / 100
	end
end

function Parameter:revolution()
	self.have = math.random()*100
	self.want = math.random()*100
	self.param = math.random()*100

	self.Shift_TotalDuration = math.random()*2
	self.Shift_DurationSoFar = 0
	self.Shift_Magnitude = (math.random()-0.5)*10
end

function Parameter:showStar(yes)
	self.starred = yes
end
