require 'middleclass'
require 'parameter'
require 'protestor'
require 'basicwalker'

Protest = class('Protest')

function Protest:initialize(parameter,toohigh)
	self.parameter = parameter
	self.toohigh = toohigh
	self.startlevel = parameter.have
	self.timesincestart = 0
	self.durationOfProtest = math.random(20)
	self.riot = false
	self.revolt = false
	self.revolted = false
	self.over = false
	self.forgotten = false

	self.position = {0,0}
	self.position[1] = math.random(200,1024-500)
	self.position[2] = math.random(400,768)

	self.members = {}
	self.populationcount = math.random(5,9)
	
	for i=1,self.populationcount do
		newmember = {}
		newmember[1] = self.position[1] + ((math.random()-0.5)*2*100)
		newmember[2] = self.position[2] + ((math.random()-0.5)*2*40)
		local comefrom = {}
		if math.random()>0.5 then
			comefrom = {0,246+math.random(500)}
		else
			comefrom = {1024,246+math.random(500)}
		end
		newmember[3] = BasicWalker:new( comefrom, {newmember[1],newmember[2]} )
		table.insert(self.members,newmember)
	end
end

function Protest:update(dt)
	for i=1,#self.members do
		self.members[i][3]:update(dt)
		if self.riot == false then
			if self.members[i][3]:stillWalking() == false then
				self.members[i][3] = Protestor:new(self.members[i][1],self.members[i][2])
			end
		end
	end

	if self.over == true then
		everyonewandered = true
		for i=1,#self.members do
			if self.members[i][3]:stillWalking() == true then everyonewandered=false end
		end
		if everyonewandered == true then 
			self.forgotten = true 
		end
	end


	if self.riot == false then
		local riot = true
		for i=1,#self.members do
			if self.members[i][3]:angry() == false then riot=false end
		end
		if riot == true then 
			self.riot = true 
			self.timeSinceStart = 0
		end

	else
		self.timeSinceStart = self.timeSinceStart + dt

		if self.over == false and self.timeSinceStart > self.durationOfProtest then
			local probRevolution = 0.1
			if self.toohigh then
				probRevolution = probRevolution + difficulty_easilyangry*(self.parameter.have - self.parameter.want)/100
				if self.parameter.have > self.parameter.want then
					probRevolution = probRevolution + 0.2
				end
			else
				probRevolution = probRevolution + difficulty_easilyangry*(self.parameter.want - self.parameter.have)/100
			end
			if math.random() < probRevolution then
				self.revolt = true
			end
			self.over = true
			self:disperse()
		end

	end
end

function Protest:isRevolution()
	if self.revolted == true then return false end
	if self.revolt == true then self.revolted = true end
	return self.revolt
end

function Protest:draw()
	for i=1,#self.members do
		self.members[i][3]:draw()
	end
end

function Protest:disperse()
	for i=1,#self.members do
		startpt = {self.members[i][1],self.members[i][2]}
		if math.random()>0.5 then
			endpt = {0,246+math.random(500)}
		else
			endpt = {1024,246+math.random(500)}
		end
		self.members[i][3] = BasicWalker:new(startpt,endpt)
	end
end
